package test.org.malai.widgets;

import java.awt.Color;

import javax.swing.JButton;

import junit.framework.TestCase;

import org.junit.Before;
import org.junit.Test;
import org.malai.widget.MButtonIcon;

public class TestButtonIcon extends TestCase {
	private MButtonIcon	bi;

	private final Color	cNull	= null;

	private final Color	c1		= new Color(100, 100, 100);

	private final Color	c2		= new Color(50, 50, 50);


	@Override
	@Before
	public void setUp() {
		bi = new MButtonIcon(c1);
	}


	@Test
	public void testConstructor() {
		try {
			new MButtonIcon(cNull);
			fail();
		}catch(IllegalArgumentException e) { /* Good */ }
	}


	@Test
	public void testPaintIcon() {
		JButton b = new JButton();

		b.setIcon(bi);
		b.repaint();
	}


	@Test
	public void testGetSetColor() {
		bi.setColor(c2);
		assertEquals(c2, bi.getColor());
		bi.setColor(cNull);
		assertEquals(c2, bi.getColor());
	}


	@Test
	public void testGetIconWidthHeight() {
		assertEquals(bi.getIconWidth(), MButtonIcon.WIDTH);
		assertEquals(bi.getIconHeight(), MButtonIcon.HEIGHT);
	}
}
